#!/usr/local/bin/python
import sys,os,re,subprocess

if os.geteuid() != 0:
    print "This utility needs to be run as 'root' to examine all processes on the system"

def cmd_get_output(cmdargs):
    return os.popen(" ".join(cmdargs)).read()

print cmd_get_output(["top -d1 | head -n 5"]).replace("\n\n", "\n")

ps = {}
rp = re.compile(r"^\s*(\d+)\s+(.+?)$")
for line in cmd_get_output(["/bin/ps", "-a", "-x", "-o", "pid,comm"]).split("\n"):
    m = rp.match(line)
    if m != None:
        ps[int(m.group(1))] = m.group(2)

rm = re.compile(r"^\s*(\d+)\s+(0x[0-9a-f]+)\s+(0x[0-9a-f]+)\s+([rwx-]+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(.+?)\s+([a-z-]+)\s*(.*)$")
maps = []
for line in cmd_get_output(["/usr/bin/procstat", "-va"]).split("\n"):
    m = rm.match(line)
    if m == None:
        continue
    maps.append({"pid" : int(m.group(1)), "start" : int(m.group(2), 0), "stop" : int(m.group(3), 0), "prt" : m.group(4), "res" : int(m.group(5)),
        "pres" : int(m.group(6)), "ref" : int(m.group(7)), "shd" : int(m.group(8)), "fl" : m.group(9), "tp" : m.group(10), "path" : m.group(11)})

mem_total = 0
mem_in_sp = 0
sp_maps = []
candidate_sp_maps = []
for m in maps:
    mem_total += m["stop"] - m["start"]
    if m["fl"].find("S") != -1:
        mem_in_sp += m["stop"] - m["start"]
        sp_maps.append(m)
    elif m["stop"] - m["start"] > 2*1024*1024:
        candidate_sp_maps.append(m)

def print_map(m, prefix=""):
    if not m["pid"] in ps:
        ps[m["pid"]] = ""
    print "%s\tpid: %d (%s) start: %x stop: %x (%d MB) tp: %s path: %s" % (prefix, m["pid"], ps[m["pid"]], m["start"], m["stop"],
            (m["stop"] - m["start"]) / (1024*1024), m["tp"], m["path"])

print "Total accounted memory mappings: %d MB (%d pages)" % (mem_total / (1024*1024), mem_total / 4096)
print "Memory in superpages: %d MB (%d mappings)" % (mem_in_sp / (1024*1024), len(sp_maps))
for m in sp_maps:
    print_map(m, "+")
print "Eligible mappings not promoted: %d" % (len(candidate_sp_maps))
for m in candidate_sp_maps:
    print_map(m, "?")
